Subject: Re: [PATCH net-next v2] net/mlx5e: Fix uninitialised struct field moder.comps

From: Leon Romanovsky <[email-masked]>
Date: Tue, 20 Apr 2021 14:05:14 +0300

On Tue, Apr 20, 2021 at 05:28:43PM +0800, Zhu Yanjun wrote:
> On Tue, Apr 20, 2021 at 5:21 PM Leon Romanovsky <[email-masked]> wrote:
> >
> > On Tue, Apr 20, 2021 at 03:09:03PM +0800, Zhu Yanjun wrote:
> > > On Tue, Apr 20, 2021 at 3:01 PM wangyunjian <[email-masked]> wrote:
> > > >
> > > > From: Yunjian Wang <[email-masked]>
> > > >
> > > > The 'comps' struct field in 'moder' is not being initialized in
> > > > mlx5e_get_def_rx_moderation() and mlx5e_get_def_tx_moderation().
> > > > So initialize 'moder' to zero to avoid the issue.
> >
> > Please state that it is false alarm and this patch doesn't fix anything
> > except broken static analyzer tool.
> >
> > > >
> > > > Addresses-Coverity: ("Uninitialized scalar variable")
> > > > Signed-off-by: Yunjian Wang <[email-masked]>
> > > > ---
> > > > v2: update mlx5e_get_def_tx_moderation() also needs fixing
> > > > ---
> > > >  drivers/net/ethernet/mellanox/mlx5/core/en_main.c | 4 ++--
> > > >  1 file changed, 2 insertions(+), 2 deletions(-)
> > > >
> > > > diff --git a/drivers/net/ethernet/mellanox/mlx5/core/en_main.c b/drivers/net/ethernet/mellanox/mlx5/core/en_main.c
> > > > index 5db63b9f3b70..17a817b7e539 100644
> > > > --- a/drivers/net/ethernet/mellanox/mlx5/core/en_main.c
> > > > +++ b/drivers/net/ethernet/mellanox/mlx5/core/en_main.c
> > > > @@ -4868,7 +4868,7 @@ static bool slow_pci_heuristic(struct mlx5_core_dev *mdev)
> > > >
> > > >  static struct dim_cq_moder mlx5e_get_def_tx_moderation(u8 cq_period_mode)
> > > >  {
> > > > -       struct dim_cq_moder moder;
> > >
> > > > +       struct dim_cq_moder moder = {};
> > >
> > > If I remember correctly, some gcc compiler will report errors about this "{}".
> >
> > Kernel doesn't support such compilers.
> 
> Are you sure? Why are you so confirmative?

Yes, I'm sure.

Please read this whole discussion, I hope that it will answer your
question on why I'm so sure.
https://lore.kernel.org/linux-rdma/[email-masked]/

> Zhu Yanjun
> > Thanks